/***************************************************************************
 *   Copyright (C) 2001 by Rick L. Vinyard, Jr.                            *
 *   rvinyard@cs.nmsu.edu                                                  *
 *                                                                         *
 *   This file is part of the conexus library.                             *
 *                                                                         *
 *   The conexus library is free software; you can redistribute it and/or  *
 *   modify it under the terms of the GNU General Public License           *
 *   version 3 as published by the Free Software Foundation.               *
 *                                                                         *
 *   The conexus library is distributed in the hope that it will be        *
 *   useful, but WITHOUT ANY WARRANTY; without even the implied warranty   *
 *   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU   *
 *   General Public License for more details.                              *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this software. If not see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/
#ifndef CONEXUSMMSERIALCOMBOBOX_H
#define CONEXUSMMSERIALCOMBOBOX_H

#include <gtkmm.h>

#include <conexus/serial.h>

namespace Conexus
{
  namespace Gtk
  {

    /**
    @author Rick L Vinyard Jr
    */
    class SerialComboBox : public ::Gtk::ComboBox
    {
      public:
        SerialComboBox(bool include_virtuals=false, bool use_enumeration=true);

        ~SerialComboBox();

        std::string device();
        
        bool include_virtuals();
        
        void set_include_virtuals(bool set=true);
        
        bool use_enumeration();
        
        void set_use_enumeration(bool set=true);

        void set_device ( const std::string& device );

      protected:
        
        bool m_include_virtuals;
        bool m_use_enumeration;
        
        void load_from_enumerated_serials();

      class ModelColumns: public ::Gtk::TreeModel::ColumnRecord
        {
          public:
            ModelColumns()
            {
              add ( description ); add ( device );
            }

            ::Gtk::TreeModelColumn<Glib::ustring> description;
            ::Gtk::TreeModelColumn<Glib::ustring> device;
        };

        ModelColumns m_modelcolumns;
        Glib::RefPtr< ::Gtk::ListStore> m_reftreemodel;

    };

  }

}

#endif
